(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define('ngx-dotnet', ['exports', '@angular/core', '@angular/common/http'], factory) :
    (global = global || self, factory(global['ngx-dotnet'] = {}, global.ng.core, global.ng.common.http));
}(this, function (exports, core, http) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DotnetMethodBinding = /** @class */ (function () {
        function DotnetMethodBinding(namespace, className, staticMethodName) {
            this.namespace = namespace;
            this.className = className;
            this.staticMethodName = staticMethodName;
        }
        return DotnetMethodBinding;
    }());
    /**
     * @template IDotnetAppMethods
     */
    var   /**
     * @template IDotnetAppMethods
     */
    DotnetApp = /** @class */ (function () {
        function DotnetApp() {
            this.methods = (/** @type {?} */ ({}));
        }
        return DotnetApp;
    }());
    var DotnetPreferences = /** @class */ (function () {
        function DotnetPreferences(path, bin, dependencyDeclarationJsonName, bindings, bclDependencies, dependencies) {
            if (bclDependencies === void 0) { bclDependencies = []; }
            if (dependencies === void 0) { dependencies = []; }
            this.path = path;
            this.bin = bin;
            this.dependencyDeclarationJsonName = dependencyDeclarationJsonName;
            this.bindings = bindings;
            this.bclDependencies = bclDependencies;
            this.dependencies = dependencies;
        }
        return DotnetPreferences;
    }());
    var DependencyDeclaration = /** @class */ (function () {
        function DependencyDeclaration() {
        }
        return DependencyDeclaration;
    }());
    // @dynamic
    var   
    // @dynamic
    Dotnet = /** @class */ (function () {
        function Dotnet() {
        }
        /**
         * @template IDotnetAppMethods
         * @param {?} dotnetSettings
         * @return {?}
         */
        Dotnet.getApplication = /**
         * @template IDotnetAppMethods
         * @param {?} dotnetSettings
         * @return {?}
         */
        function (dotnetSettings) {
            var _this_1 = this;
            this.waitToReadyTask = new Promise((/**
             * @param {?} resolve
             * @return {?}
             */
            function (resolve) {
                _this_1.resolveWaitToReadyTask = resolve;
            }));
            if (!this.dotnetApp) {
                this.dotnetApp = new DotnetApp();
                this.bindings = dotnetSettings.bindings;
                this.runtime = (/** @type {?} */ ({
                    onRuntimeInitialized: (/**
                     * @return {?}
                     */
                    function () {
                        MONO.mono_load_runtime_and_bcl(dotnetSettings.bin, dotnetSettings.bin, 0, dotnetSettings.dependencies
                            .concat(dotnetSettings.bclDependencies)
                            .map((/**
                         * @param {?} d
                         * @return {?}
                         */
                        function (d) { return d + ".dll"; })), (/**
                         * @return {?}
                         */
                        function () {
                            /** @type {?} */
                            var wasmBindingsLib = 'WebAssembly.Bindings';
                            /** @type {?} */
                            var wasmBinding = "[" + wasmBindingsLib + "]WebAssembly.Runtime";
                            /** @type {?} */
                            var _this = Dotnet;
                            _this.runtime.mono_bindings_init(wasmBinding);
                            _this.bindings.forEach((/**
                             * @param {?} b
                             * @return {?}
                             */
                            function (b) {
                                _this.dotnetApp.methods[b.staticMethodName] = _this.runtime
                                    .mono_bind_static_method("[" + b.namespace + "] " + b.namespace + "." + b.className + ":" + b.staticMethodName);
                            }));
                            _this.resolveWaitToReadyTask();
                        }));
                    })
                }));
                window['Module'] = this.runtime;
            }
            else {
                this.resolveWaitToReadyTask();
            }
            return this.dotnetApp;
        };
        return Dotnet;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var BclDependencies = [
        'I18N',
        'I18N.CJK',
        'I18N.MidEast',
        'I18N.Other',
        'I18N.Rare',
        'I18N.West',
        'Microsoft.CSharp',
        'Microsoft.Win32.Primitives',
        'Microsoft.Win32.Registry',
        'Microsoft.Win32.Registry.AccessControl',
        'Mono.Security',
        'mscorlib',
        'netstandard',
        'nunitlite',
        'System',
        'System.AppContext',
        'System.Buffers',
        'System.Collections',
        'System.Collections.Concurrent',
        'System.Collections.NonGeneric',
        'System.Collections.Specialized',
        'System.ComponentModel',
        'System.ComponentModel.Annotations',
        'System.ComponentModel.Composition',
        'System.ComponentModel.DataAnnotations',
        'System.ComponentModel.EventBasedAsync',
        'System.ComponentModel.Primitives',
        'System.ComponentModel.TypeConverter',
        'System.Console',
        'System.Core',
        'System.Data',
        'System.Data.Common',
        'System.Data.DataSetExtensions',
        'System.Data.SqlClient',
        'System.Diagnostics.Contracts',
        'System.Diagnostics.Debug',
        'System.Diagnostics.FileVersionInfo',
        'System.Diagnostics.Process',
        'System.Diagnostics.StackTrace',
        'System.Diagnostics.TextWriterTraceListener',
        'System.Diagnostics.Tools',
        'System.Diagnostics.TraceEvent',
        'System.Diagnostics.TraceSource',
        'System.Diagnostics.Tracing',
        'System.Drawing.Common',
        'System.Drawing.Primitives',
        'System.Dynamic.Runtime',
        'System.Globalization',
        'System.Globalization.Calendars',
        'System.Globalization.Extensions',
        'System.IO',
        'System.IO.Compression',
        'System.IO.Compression.FileSystem',
        'System.IO.Compression.ZipFile',
        'System.IO.FileSystem',
        'System.IO.FileSystem.AccessControl',
        'System.IO.FileSystem.DriveInfo',
        'System.IO.FileSystem.Primitives',
        'System.IO.FileSystem.Watcher',
        'System.IO.IsolatedStorage',
        'System.IO.MemoryMappedFiles',
        'System.IO.Pipes',
        'System.IO.UnmanagedMemoryStream',
        'System.Linq',
        'System.Linq.Expressions',
        'System.Linq.Parallel',
        'System.Linq.Queryable',
        'System.Memory',
        'System.Net.AuthenticationManager',
        'System.Net.Cache',
        'System.Net.Http',
        'System.Net.HttpListener',
        'System.Net.Mail',
        'System.Net.NameResolution',
        'System.Net.NetworkInformation',
        'System.Net.Ping',
        'System.Net.Primitives',
        'System.Net.Requests',
        'System.Net.Security',
        'System.Net.ServicePoint',
        'System.Net.Sockets',
        'System.Net.Utilities',
        'System.Net.WebHeaderCollection',
        'System.Net.WebSockets',
        'System.Net.WebSockets.Client',
        'System.Numerics',
        'System.Numerics.Vectors',
        'System.ObjectModel',
        'System.Reflection',
        'System.Reflection.DispatchProxy',
        'System.Reflection.Emit',
        'System.Reflection.Emit.ILGeneration',
        'System.Reflection.Emit.Lightweight',
        'System.Reflection.Extensions',
        'System.Reflection.Primitives',
        'System.Reflection.TypeExtensions',
        'System.Resources.Reader',
        'System.Resources.ReaderWriter',
        'System.Resources.ResourceManager',
        'System.Resources.Writer',
        'System.Runtime',
        'System.Runtime.CompilerServices.Unsafe',
        'System.Runtime.CompilerServices.VisualC',
        'System.Runtime.Extensions',
        'System.Runtime.Handles',
        'System.Runtime.InteropServices',
        'System.Runtime.InteropServices.RuntimeInformation',
        'System.Runtime.InteropServices.WindowsRuntime',
        'System.Runtime.Loader',
        'System.Runtime.Numerics',
        'System.Runtime.Serialization',
        'System.Runtime.Serialization.Formatters',
        'System.Runtime.Serialization.Json',
        'System.Runtime.Serialization.Primitives',
        'System.Runtime.Serialization.Xml',
        'System.Security',
        'System.Security.AccessControl',
        'System.Security.Claims',
        'System.Security.Cryptography.Algorithms',
        'System.Security.Cryptography.Cng',
        'System.Security.Cryptography.Csp',
        'System.Security.Cryptography.DeriveBytes',
        'System.Security.Cryptography.Encoding',
        'System.Security.Cryptography.Encryption',
        'System.Security.Cryptography.Encryption.Aes',
        'System.Security.Cryptography.Encryption.ECDiffieHellman',
        'System.Security.Cryptography.Encryption.ECDsa',
        'System.Security.Cryptography.Hashing',
        'System.Security.Cryptography.Hashing.Algorithms',
        'System.Security.Cryptography.OpenSsl',
        'System.Security.Cryptography.Pkcs',
        'System.Security.Cryptography.Primitives',
        'System.Security.Cryptography.ProtectedData',
        'System.Security.Cryptography.RandomNumberGenerator',
        'System.Security.Cryptography.RSA',
        'System.Security.Cryptography.X509Certificates',
        'System.Security.Principal',
        'System.Security.Principal.Windows',
        'System.Security.SecureString',
        'System.ServiceModel.Internals',
        'System.ServiceProcess.ServiceController',
        'System.Text.Encoding',
        'System.Text.Encoding.CodePages',
        'System.Text.Encoding.Extensions',
        'System.Text.RegularExpressions',
        'System.Threading',
        'System.Threading.AccessControl',
        'System.Threading.Overlapped',
        'System.Threading.Tasks',
        'System.Threading.Tasks.Extensions',
        'System.Threading.Tasks.Parallel',
        'System.Threading.Thread',
        'System.Threading.ThreadPool',
        'System.Threading.Timer',
        'System.Transactions',
        'System.ValueTuple',
        'System.Xml',
        'System.Xml.Linq',
        'System.Xml.ReaderWriter',
        'System.Xml.XDocument',
        'System.Xml.XmlDocument',
        'System.Xml.XmlSerializer',
        'System.Xml.XPath',
        'System.Xml.XPath.XDocument',
        'System.Xml.XPath.XmlDocument',
        'System.Xml.Xsl.Primitives',
        'WebAssembly.Bindings',
        'WebAssembly.Net.Http',
        'WebAssembly.Net.WebSockets'
    ];

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var RequiredBclDependencies = [
        'mscorlib',
        'netstandard',
        'System',
        'WebAssembly.Bindings'
    ];

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxDotnetService = /** @class */ (function () {
        function NgxDotnetService(httpClient) {
            this.httpClient = httpClient;
        }
        /**
         * @template IDotnetAppMethods
         * @param {?} preferences
         * @return {?}
         */
        NgxDotnetService.prototype.getApplicationAsync = /**
         * @template IDotnetAppMethods
         * @param {?} preferences
         * @return {?}
         */
        function (preferences) {
            return __awaiter(this, void 0, void 0, function () {
                var dotnetApp;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.initDependenciesAsync(preferences)];
                        case 1:
                            _a.sent();
                            dotnetApp = Dotnet.getApplication(preferences);
                            return [4 /*yield*/, this.bootstrapMonoRuntimeAsync(preferences.path)];
                        case 2:
                            _a.sent();
                            return [2 /*return*/, dotnetApp];
                    }
                });
            });
        };
        /**
         * @private
         * @param {?} preferences
         * @return {?}
         */
        NgxDotnetService.prototype.initDependenciesAsync = /**
         * @private
         * @param {?} preferences
         * @return {?}
         */
        function (preferences) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            RequiredBclDependencies.forEach((/**
                             * @param {?} d
                             * @return {?}
                             */
                            function (d) {
                                preferences.bclDependencies.push(d);
                            }));
                            if (!preferences.dependencyDeclarationJsonName) return [3 /*break*/, 2];
                            return [4 /*yield*/, this.actualizeDependenciesByDeclarationsAsync(preferences)];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @private
         * @param {?} preferences
         * @return {?}
         */
        NgxDotnetService.prototype.actualizeDependenciesByDeclarationsAsync = /**
         * @private
         * @param {?} preferences
         * @return {?}
         */
        function (preferences) {
            return __awaiter(this, void 0, void 0, function () {
                var normalizedBclDependencies, dependencyDeclarations;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            normalizedBclDependencies = BclDependencies.map((/**
                             * @param {?} d
                             * @return {?}
                             */
                            function (d) { return d.toLowerCase(); }));
                            return [4 /*yield*/, this.getDependencyDeclarationsAsync(preferences)];
                        case 1:
                            dependencyDeclarations = _a.sent();
                            dependencyDeclarations.forEach((/**
                             * @param {?} d
                             * @return {?}
                             */
                            function (d) {
                                if (d.serviceable) {
                                    /** @type {?} */
                                    var normalizedName = d.name.toLowerCase();
                                    /** @type {?} */
                                    var index = normalizedBclDependencies.indexOf(normalizedName);
                                    if (index >= 0) {
                                        /** @type {?} */
                                        var name_1 = BclDependencies[index];
                                        preferences.bclDependencies.push(name_1);
                                    }
                                }
                                else {
                                    preferences.dependencies.push(d.name);
                                }
                            }));
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @private
         * @param {?} preferences
         * @return {?}
         */
        NgxDotnetService.prototype.getDependencyDeclarationsAsync = /**
         * @private
         * @param {?} preferences
         * @return {?}
         */
        function (preferences) {
            return __awaiter(this, void 0, void 0, function () {
                var result, dependencyDeclarations, key, l, dep;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.httpClient.get("/" + preferences.path + "/" + preferences.bin + "/" + preferences.dependencyDeclarationJsonName + ".json").toPromise()];
                        case 1:
                            result = (/** @type {?} */ (_a.sent()));
                            dependencyDeclarations = [];
                            for (key in result.libraries) {
                                if (result.libraries.hasOwnProperty(key)) {
                                    l = result.libraries[key];
                                    dep = {
                                        name: "" + key.split('/')[0],
                                        serviceable: l.serviceable
                                    };
                                    dependencyDeclarations.push(dep);
                                }
                            }
                            return [2 /*return*/, dependencyDeclarations];
                    }
                });
            });
        };
        /**
         * @private
         * @param {?} path
         * @return {?}
         */
        NgxDotnetService.prototype.bootstrapMonoRuntimeAsync = /**
         * @private
         * @param {?} path
         * @return {?}
         */
        function (path) {
            return __awaiter(this, void 0, void 0, function () {
                var scriptElement, el;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            scriptElement = document.createElement('script');
                            scriptElement.async = true;
                            scriptElement.src = path + "/dotnet.js";
                            el = document.getElementsByTagName('script')[0];
                            el.parentNode.insertBefore(scriptElement, el);
                            return [4 /*yield*/, Dotnet.waitToReadyTask];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        NgxDotnetService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        NgxDotnetService.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        return NgxDotnetService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxDotnetModule = /** @class */ (function () {
        function NgxDotnetModule() {
        }
        NgxDotnetModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            http.HttpClientModule
                        ],
                        providers: [
                            NgxDotnetService
                        ]
                    },] }
        ];
        return NgxDotnetModule;
    }());

    exports.DependencyDeclaration = DependencyDeclaration;
    exports.Dotnet = Dotnet;
    exports.DotnetApp = DotnetApp;
    exports.DotnetMethodBinding = DotnetMethodBinding;
    exports.DotnetPreferences = DotnetPreferences;
    exports.NgxDotnetModule = NgxDotnetModule;
    exports.NgxDotnetService = NgxDotnetService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-dotnet.umd.js.map
