import { __awaiter } from 'tslib';
import { Injectable, NgModule } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class DotnetMethodBinding {
    /**
     * @param {?} namespace
     * @param {?} className
     * @param {?} staticMethodName
     */
    constructor(namespace, className, staticMethodName) {
        this.namespace = namespace;
        this.className = className;
        this.staticMethodName = staticMethodName;
    }
}
/**
 * @template IDotnetAppMethods
 */
class DotnetApp {
    constructor() {
        this.methods = (/** @type {?} */ ({}));
    }
}
class DotnetPreferences {
    /**
     * @param {?} path
     * @param {?} bin
     * @param {?} dependencyDeclarationJsonName
     * @param {?} bindings
     * @param {?=} bclDependencies
     * @param {?=} dependencies
     */
    constructor(path, bin, dependencyDeclarationJsonName, bindings, bclDependencies = [], dependencies = []) {
        this.path = path;
        this.bin = bin;
        this.dependencyDeclarationJsonName = dependencyDeclarationJsonName;
        this.bindings = bindings;
        this.bclDependencies = bclDependencies;
        this.dependencies = dependencies;
    }
}
class DependencyDeclaration {
}
// @dynamic
class Dotnet {
    /**
     * @template IDotnetAppMethods
     * @param {?} dotnetSettings
     * @return {?}
     */
    static getApplication(dotnetSettings) {
        this.waitToReadyTask = new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        resolve => {
            this.resolveWaitToReadyTask = resolve;
        }));
        if (!this.dotnetApp) {
            this.dotnetApp = new DotnetApp();
            this.bindings = dotnetSettings.bindings;
            this.runtime = (/** @type {?} */ ({
                onRuntimeInitialized: (/**
                 * @return {?}
                 */
                () => {
                    MONO.mono_load_runtime_and_bcl(dotnetSettings.bin, dotnetSettings.bin, 0, dotnetSettings.dependencies
                        .concat(dotnetSettings.bclDependencies)
                        .map((/**
                     * @param {?} d
                     * @return {?}
                     */
                    d => `${d}.dll`)), (/**
                     * @return {?}
                     */
                    () => {
                        /** @type {?} */
                        const wasmBindingsLib = 'WebAssembly.Bindings';
                        /** @type {?} */
                        const wasmBinding = `[${wasmBindingsLib}]WebAssembly.Runtime`;
                        /** @type {?} */
                        const _this = Dotnet;
                        _this.runtime.mono_bindings_init(wasmBinding);
                        _this.bindings.forEach((/**
                         * @param {?} b
                         * @return {?}
                         */
                        (b) => {
                            _this.dotnetApp.methods[b.staticMethodName] = _this.runtime
                                .mono_bind_static_method(`[${b.namespace}] ${b.namespace}.${b.className}:${b.staticMethodName}`);
                        }));
                        _this.resolveWaitToReadyTask();
                    }));
                })
            }));
            window['Module'] = this.runtime;
        }
        else {
            this.resolveWaitToReadyTask();
        }
        return this.dotnetApp;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const BclDependencies = [
    'I18N',
    'I18N.CJK',
    'I18N.MidEast',
    'I18N.Other',
    'I18N.Rare',
    'I18N.West',
    'Microsoft.CSharp',
    'Microsoft.Win32.Primitives',
    'Microsoft.Win32.Registry',
    'Microsoft.Win32.Registry.AccessControl',
    'Mono.Security',
    'mscorlib',
    'netstandard',
    'nunitlite',
    'System',
    'System.AppContext',
    'System.Buffers',
    'System.Collections',
    'System.Collections.Concurrent',
    'System.Collections.NonGeneric',
    'System.Collections.Specialized',
    'System.ComponentModel',
    'System.ComponentModel.Annotations',
    'System.ComponentModel.Composition',
    'System.ComponentModel.DataAnnotations',
    'System.ComponentModel.EventBasedAsync',
    'System.ComponentModel.Primitives',
    'System.ComponentModel.TypeConverter',
    'System.Console',
    'System.Core',
    'System.Data',
    'System.Data.Common',
    'System.Data.DataSetExtensions',
    'System.Data.SqlClient',
    'System.Diagnostics.Contracts',
    'System.Diagnostics.Debug',
    'System.Diagnostics.FileVersionInfo',
    'System.Diagnostics.Process',
    'System.Diagnostics.StackTrace',
    'System.Diagnostics.TextWriterTraceListener',
    'System.Diagnostics.Tools',
    'System.Diagnostics.TraceEvent',
    'System.Diagnostics.TraceSource',
    'System.Diagnostics.Tracing',
    'System.Drawing.Common',
    'System.Drawing.Primitives',
    'System.Dynamic.Runtime',
    'System.Globalization',
    'System.Globalization.Calendars',
    'System.Globalization.Extensions',
    'System.IO',
    'System.IO.Compression',
    'System.IO.Compression.FileSystem',
    'System.IO.Compression.ZipFile',
    'System.IO.FileSystem',
    'System.IO.FileSystem.AccessControl',
    'System.IO.FileSystem.DriveInfo',
    'System.IO.FileSystem.Primitives',
    'System.IO.FileSystem.Watcher',
    'System.IO.IsolatedStorage',
    'System.IO.MemoryMappedFiles',
    'System.IO.Pipes',
    'System.IO.UnmanagedMemoryStream',
    'System.Linq',
    'System.Linq.Expressions',
    'System.Linq.Parallel',
    'System.Linq.Queryable',
    'System.Memory',
    'System.Net.AuthenticationManager',
    'System.Net.Cache',
    'System.Net.Http',
    'System.Net.HttpListener',
    'System.Net.Mail',
    'System.Net.NameResolution',
    'System.Net.NetworkInformation',
    'System.Net.Ping',
    'System.Net.Primitives',
    'System.Net.Requests',
    'System.Net.Security',
    'System.Net.ServicePoint',
    'System.Net.Sockets',
    'System.Net.Utilities',
    'System.Net.WebHeaderCollection',
    'System.Net.WebSockets',
    'System.Net.WebSockets.Client',
    'System.Numerics',
    'System.Numerics.Vectors',
    'System.ObjectModel',
    'System.Reflection',
    'System.Reflection.DispatchProxy',
    'System.Reflection.Emit',
    'System.Reflection.Emit.ILGeneration',
    'System.Reflection.Emit.Lightweight',
    'System.Reflection.Extensions',
    'System.Reflection.Primitives',
    'System.Reflection.TypeExtensions',
    'System.Resources.Reader',
    'System.Resources.ReaderWriter',
    'System.Resources.ResourceManager',
    'System.Resources.Writer',
    'System.Runtime',
    'System.Runtime.CompilerServices.Unsafe',
    'System.Runtime.CompilerServices.VisualC',
    'System.Runtime.Extensions',
    'System.Runtime.Handles',
    'System.Runtime.InteropServices',
    'System.Runtime.InteropServices.RuntimeInformation',
    'System.Runtime.InteropServices.WindowsRuntime',
    'System.Runtime.Loader',
    'System.Runtime.Numerics',
    'System.Runtime.Serialization',
    'System.Runtime.Serialization.Formatters',
    'System.Runtime.Serialization.Json',
    'System.Runtime.Serialization.Primitives',
    'System.Runtime.Serialization.Xml',
    'System.Security',
    'System.Security.AccessControl',
    'System.Security.Claims',
    'System.Security.Cryptography.Algorithms',
    'System.Security.Cryptography.Cng',
    'System.Security.Cryptography.Csp',
    'System.Security.Cryptography.DeriveBytes',
    'System.Security.Cryptography.Encoding',
    'System.Security.Cryptography.Encryption',
    'System.Security.Cryptography.Encryption.Aes',
    'System.Security.Cryptography.Encryption.ECDiffieHellman',
    'System.Security.Cryptography.Encryption.ECDsa',
    'System.Security.Cryptography.Hashing',
    'System.Security.Cryptography.Hashing.Algorithms',
    'System.Security.Cryptography.OpenSsl',
    'System.Security.Cryptography.Pkcs',
    'System.Security.Cryptography.Primitives',
    'System.Security.Cryptography.ProtectedData',
    'System.Security.Cryptography.RandomNumberGenerator',
    'System.Security.Cryptography.RSA',
    'System.Security.Cryptography.X509Certificates',
    'System.Security.Principal',
    'System.Security.Principal.Windows',
    'System.Security.SecureString',
    'System.ServiceModel.Internals',
    'System.ServiceProcess.ServiceController',
    'System.Text.Encoding',
    'System.Text.Encoding.CodePages',
    'System.Text.Encoding.Extensions',
    'System.Text.RegularExpressions',
    'System.Threading',
    'System.Threading.AccessControl',
    'System.Threading.Overlapped',
    'System.Threading.Tasks',
    'System.Threading.Tasks.Extensions',
    'System.Threading.Tasks.Parallel',
    'System.Threading.Thread',
    'System.Threading.ThreadPool',
    'System.Threading.Timer',
    'System.Transactions',
    'System.ValueTuple',
    'System.Xml',
    'System.Xml.Linq',
    'System.Xml.ReaderWriter',
    'System.Xml.XDocument',
    'System.Xml.XmlDocument',
    'System.Xml.XmlSerializer',
    'System.Xml.XPath',
    'System.Xml.XPath.XDocument',
    'System.Xml.XPath.XmlDocument',
    'System.Xml.Xsl.Primitives',
    'WebAssembly.Bindings',
    'WebAssembly.Net.Http',
    'WebAssembly.Net.WebSockets'
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const RequiredBclDependencies = [
    'mscorlib',
    'netstandard',
    'System',
    'WebAssembly.Bindings'
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxDotnetService {
    /**
     * @param {?} httpClient
     */
    constructor(httpClient) {
        this.httpClient = httpClient;
    }
    /**
     * @template IDotnetAppMethods
     * @param {?} preferences
     * @return {?}
     */
    getApplicationAsync(preferences) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.initDependenciesAsync(preferences);
            /** @type {?} */
            const dotnetApp = Dotnet.getApplication(preferences);
            yield this.bootstrapMonoRuntimeAsync(preferences.path);
            return dotnetApp;
        });
    }
    /**
     * @private
     * @param {?} preferences
     * @return {?}
     */
    initDependenciesAsync(preferences) {
        return __awaiter(this, void 0, void 0, function* () {
            RequiredBclDependencies.forEach((/**
             * @param {?} d
             * @return {?}
             */
            d => {
                preferences.bclDependencies.push(d);
            }));
            if (preferences.dependencyDeclarationJsonName) {
                yield this.actualizeDependenciesByDeclarationsAsync(preferences);
            }
        });
    }
    /**
     * @private
     * @param {?} preferences
     * @return {?}
     */
    actualizeDependenciesByDeclarationsAsync(preferences) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            const normalizedBclDependencies = BclDependencies.map((/**
             * @param {?} d
             * @return {?}
             */
            d => d.toLowerCase()));
            /** @type {?} */
            const dependencyDeclarations = yield this.getDependencyDeclarationsAsync(preferences);
            dependencyDeclarations.forEach((/**
             * @param {?} d
             * @return {?}
             */
            d => {
                if (d.serviceable) {
                    /** @type {?} */
                    const normalizedName = d.name.toLowerCase();
                    /** @type {?} */
                    const index = normalizedBclDependencies.indexOf(normalizedName);
                    if (index >= 0) {
                        /** @type {?} */
                        const name = BclDependencies[index];
                        preferences.bclDependencies.push(name);
                    }
                }
                else {
                    preferences.dependencies.push(d.name);
                }
            }));
        });
    }
    /**
     * @private
     * @param {?} preferences
     * @return {?}
     */
    getDependencyDeclarationsAsync(preferences) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            const result = (/** @type {?} */ (yield this.httpClient.get(`/${preferences.path}/${preferences.bin}/${preferences.dependencyDeclarationJsonName}.json`).toPromise()));
            /** @type {?} */
            const dependencyDeclarations = [];
            for (const key in result.libraries) {
                if (result.libraries.hasOwnProperty(key)) {
                    /** @type {?} */
                    const l = result.libraries[key];
                    /** @type {?} */
                    const dep = {
                        name: `${key.split('/')[0]}`,
                        serviceable: l.serviceable
                    };
                    dependencyDeclarations.push(dep);
                }
            }
            return dependencyDeclarations;
        });
    }
    /**
     * @private
     * @param {?} path
     * @return {?}
     */
    bootstrapMonoRuntimeAsync(path) {
        return __awaiter(this, void 0, void 0, function* () {
            /** @type {?} */
            const scriptElement = document.createElement('script');
            scriptElement.async = true;
            scriptElement.src = `${path}/dotnet.js`;
            /** @type {?} */
            const el = document.getElementsByTagName('script')[0];
            el.parentNode.insertBefore(scriptElement, el);
            yield Dotnet.waitToReadyTask;
        });
    }
}
NgxDotnetService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
NgxDotnetService.ctorParameters = () => [
    { type: HttpClient }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxDotnetModule {
}
NgxDotnetModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    HttpClientModule
                ],
                providers: [
                    NgxDotnetService
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DependencyDeclaration, Dotnet, DotnetApp, DotnetMethodBinding, DotnetPreferences, NgxDotnetModule, NgxDotnetService };
//# sourceMappingURL=ngx-dotnet.js.map
