import { BclDependency } from './bcl-dependency';
export declare class DotnetMethodBinding {
    namespace: string;
    className: string;
    staticMethodName: string;
    constructor(namespace: string, className: string, staticMethodName: string);
}
export declare class DotnetApp<IDotnetAppMethods> {
    methods: IDotnetAppMethods;
    constructor();
}
export declare class DotnetPreferences {
    path: string;
    bin: string;
    dependencyDeclarationJsonName: string;
    bindings: Array<DotnetMethodBinding>;
    bclDependencies: Array<BclDependency>;
    dependencies: Array<string>;
    constructor(path: string, bin: string, dependencyDeclarationJsonName: string, bindings: Array<DotnetMethodBinding>, bclDependencies?: Array<BclDependency>, dependencies?: Array<string>);
}
export declare class DependencyDeclaration {
    name: string;
    serviceable: boolean;
}
export declare class Dotnet {
    static waitToReadyTask: Promise<void>;
    private static dotnetApp;
    private static bindings;
    private static runtime;
    private static resolveWaitToReadyTask;
    static getApplication<IDotnetAppMethods>(dotnetSettings: DotnetPreferences): DotnetApp<IDotnetAppMethods>;
}
